#ifndef EEBIE_H
#define EEBIE_H

#include<stdint.h>
#include<stddef.h>

typedef enum EBMLElementType {
	EBML_SIGNED_INTEGER,
	EBML_UNSIGNED_INTEGER,
	EBML_FLOAT4,
	EBML_FLOAT8,
	EBML_STRING,
	EBML_UTF8,
	EBML_DATE,
	EBML_TREE,
	EBML_BINARY,
} EBMLElementType;

typedef struct EBMLBinary {
	uint8_t *ptr;
	size_t length;
} EBMLBinary;

typedef union EBMLPrimitive {
	int64_t sInt;
	uint64_t uInt;
	float flt4;
	double flt8;
	const char *string;
	const EBMLBinary binary;
	uint64_t date;
} EBMLPrimitive;

#endif
