#ifndef EEBIE_WRITER_H
#define EEBIE_WRITER_H

#include"ebml.h"

#include<stddef.h>
#include<stdbool.h>

#define EBML_WRITE_MAXIMUM_DEPTH 128

struct EBMLWriter;

typedef size_t(*EBMLEventWrite)(struct EBMLWriter*, const void *data, size_t length);
typedef void*(*EBMLEventAlloc)(struct EBMLWriter*, void *data, size_t length);

typedef struct EBMLWriter {
	int currentDepth;
	uint64_t stack[EBML_WRITE_MAXIMUM_DEPTH];
	
	EBMLEventWrite eventWrite;
	EBMLEventAlloc eventAlloc;
	
	uint8_t *buffer;
	size_t bufferLen;
	size_t bufferCapacity;
	
	void *ud;
} EBMLWriter;

void ebml_writer_init(EBMLWriter *this);
void ebml_writer_free(EBMLWriter *this);

void ebml_writer_push_ind(EBMLWriter *this, uint64_t id);
void ebml_writer_push(EBMLWriter *this, uint64_t id);
void ebml_writer_pop(EBMLWriter *this);

bool ebml_writer_flush(EBMLWriter *this);

void ebml_writer_put(EBMLWriter *this, uint64_t id, EBMLElementType type, EBMLPrimitive primitive);

#endif
